<template>
  <div>
    <loading-dots v-if="saving" />
    <div class="field" v-for="(field, index) in fields" :key="index">
      <component
        :is="type(field)"
        :value="get(field, update, outgoing, value)"
        @input="onInput(field, arguments[0], index)"
        :label="field.label"
        :placeholder="field.placeholder"
      />
    </div>
  </div>
</template>
<style lang="scss">
@import "~assets/mixins.scss";

.loading-dots {
  position: absolute;
  top: $grid;
  right: $grid;
}
</style>
<script>
import ObjectEditor, { updateAccessor } from "./mixins/ObjectEditor";

import LoadingDots from "./LoadingDots";

var types = {
  text: () => import("./fields/TextField.vue").then((x) => x.default),
  boolean: () => import("./fields/Checkbox.vue").then((x) => x.default),
};

export default {
  props: ["fields"],
  components: { LoadingDots },
  mixins: [ObjectEditor],
  data() {
    return {};
  },
  watch: {},
  methods: {
    get(field, ...options) {
      for (var i in options) {
        var v = options[i][field.key];
        if (v) return v;
      }
      return null;
    },
    onInput(field, value, index) {
      this.update = { ...this.update, [field.key]: value };
      this.onChange();
    },
    type(field) {
      var type = field.type;
      return types[type];
    },
  },
};
</script>
